import { Locale } from '../config';
import { Filter, Sort, Target } from '../data';
import { WidgetRenderEnv } from '../widget';
import { ThemeProvide } from './theme';
import { WidgetDataOptionColumn_Server, WidgetRepresent } from './widget';
export declare enum Input {
    Change = "ptnl.input.change",
    ChangeLang = "ptnl.input.changeLang",
    ChangeTheme = "ptnl.input.changeTheme",
    ChangeOtherFilters = "ptnl.input.ChangeOtherFilters",
    ChangeWidgetRenderEnv = "ptnl.input.changeWidgetRenderEnv"
}
export declare enum Output {
    Init = "ptnl.output.init",
    Ready = "ptnl.output.ready",
    SetFilter = "ptnl.output.setFilter",
    RemoveFilterAt = "ptnl.output.RemoveFilterAt",
    SetSort = "ptnl.output.setSort",
    RemoveSortAt = "ptnl.output.RemoveSortAt",
    Interact = "ptnl.output.interact"
}
export interface InputParameter extends Record<Input, any> {
    [Input.Change]: WidgetRepresent;
    [Input.ChangeLang]: Locale;
    [Input.ChangeTheme]: ThemeProvide;
    [Input.ChangeOtherFilters]: WidgetDataOptionColumn_Server[];
    [Input.ChangeWidgetRenderEnv]: WidgetRenderEnv;
}
export interface OutputParameter extends Record<Output, any> {
    [Output.Init]: void;
    [Output.Ready]: void;
    [Output.SetFilter]: {
        filter: Filter;
        target: Target;
        rowIndex: number;
    };
    [Output.RemoveFilterAt]: {
        index: number;
    };
    [Output.SetSort]: {
        sort: Sort;
        target: Target;
    };
    [Output.RemoveSortAt]: {
        index: number;
    };
    [Output.Interact]: {
        dataOptionId: number;
        dataIndex: number;
    };
}
export interface OutputData {
    token: string;
    type: Output;
    payload?: any;
}
